// ----------------------------------------------------------------------------
//
// PneuTuer.PAS                                          Ulrich Mller 23.12.99
//                                                       Procida 400NT  Delphi4
// Pneumatische Tr : Delphi4 Adaption des LLWin Programms PneuTuer.MDL
//                            der Pneumatic Robots
//
// Tr ffnet, wenn sie leicht angestoen wird (Taster 1 ffnet) und schliet,
// wenn die Lichtschranke anspricht.
// Der jeweilige Status wird auf der Form angezeigt (lblStatus)
//
// Nutzung umFish.DLL, ggf. PortNamen anpassen
//
// ----------------------------------------------------------------------------

unit PneuTuerMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TfrmTuerMain = class(TForm)
    cmdStart: TButton;
    cmdHalt: TButton;
    cmdEnde: TButton;
    lblTitel: TLabel;
    lblCopyright: TLabel;
    lblStatus: TLabel;
    procedure cmdEndeClick(Sender: TObject);
    procedure cmdHaltClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmdStartClick(Sender: TObject);
  private
    procedure Init();
    procedure TuerAuf();
    procedure TuerMain();
    procedure TuerZu();
  public
    { Public-Deklarationen}
  end;

  var
     frmTuerMain: TfrmTuerMain;

implementation

{$R *.DFM}

uses umFish;

const
     cvTuerAuf=1; cvTuerZu=2;       // --- Magnetventile
     ctTuerZu=1;                    // --- Taster
     cpLichtSchranke=2;             // --- Photowiderstand
     clLichtSchranke=3;             // --- Lampe
     cmKompressor=4;                // --- Motor
var
  FishFace: TftiDCB; pFishFace: TpftiDCB;

procedure TfrmTuerMain.cmdEndeClick(Sender: TObject);
begin
     close;
end;

procedure TfrmTuerMain.cmdHaltClick(Sender: TObject);
// --- Setzen NotHalt, um Ende einzuleiten ----------
begin
     cmdStart.SetFocus;
     NotHalt := true;
end;

procedure TfrmTuerMain.FormCreate(Sender: TObject);
begin
     pFishFace := @FishFace;
     NotHalt := true;
end;

procedure TfrmTuerMain.cmdStartClick(Sender: TObject);
// --------- Starten der Trsteuerung ----------------
begin
     cmdHalt.SetFocus;
     if NotHalt then              // --- Ist beim Programmstart true
     begin
          NotHalt := false;
          if OpenInterface(pFishFace, 'COM1') = ftiFehler then
          begin
            MessageDlg('InterfaceProblem', mtInformation,[mbOK], 0);
            exit;
          end;                                    { ggf COMx anpassen }
          TuerMain;               // --- TrSteuerung
          ClearMotors(pFishFace); // --- Ende
          cmdStart.SetFocus;
          lblStatus.Caption := 'START/ENDE';
          CloseInterface(pFishFace);
     end;
end;

procedure TfrmTuerMain.Init;
// --- Initialisierung -----
begin
  lblStatus.Caption := 'Init luft';
  SetMotor(pFishFace, clLichtSchranke, ftiEin);  // --- Lampe Lichtschranke ein
  SetMotor(pFishFace, cmKompressor, ftiEin);     // --- Kompressor ein
  WaitForTime(pFishFace, 12000);                 // --- Warten auf Druck
  SetMotor(pFishFace, cvTuerAuf, ftiAus);        // --- Tr schlieen
  SetMotor(pFishFace, cvTuerZu, ftiEin);         //     Schlieventil ein
  WaitForInput(pFishFace, ctTuerZu);             //     Warten TrZu
  SetMotor(pFishFace, cvTuerZu, ftiAus);         // --- Schlieventil aus
end;

procedure TfrmTuerMain.TuerAuf;
// --- Tr ffnen -------------
begin
  SetMotor(pFishFace, cvTuerZu, ftiAus);         // --- Schlieventil aus
  SetMotor(pFishFace, cvTuerAuf, ftiEin);        // --- ffnerventil ein
  WaitForTime(pFishFace, 500);                   //     Warten ffnen
  SetMotor(pFishFace, cvTuerAuf, ftiAus);        // --- ffnerventil aus
end;

procedure TfrmTuerMain.TuerMain;
// --- Hauptprogramm, Schleife wird ber NotHalt beendet ---
begin
  Init;                                          // --- Ausgangsstellung
  lblStatus.Caption := 'Tr geschlossen';
  repeat                                         // --- Schleife bis NotHalt
    WaitForInput(pFishFace, ctTuerZu, false);    // --- Warten TrSchubs
    TuerAuf;                                     // --- Tr ffnen
    lblStatus.Caption := 'Tr geffnet';
    WaitForInput(pFishFace, cpLichtSchranke, false); // Schlieen, wenn Lichts.
    lblStatus.Caption := 'Tr schliet';
    TuerZu;                                      // --- Tr Schlieen
    lblStatus.Caption := 'Tr geschlossen';
   until NotHalt;
end;

procedure TfrmTuerMain.TuerZu;
// --- Tr Schlieen ---------
begin
  SetMotor(pFishFace, cvTuerAuf, ftiAus);       // --- ffnerventil aus
  SetMotor(pFishFace, cvTuerZu, ftiEin);        // --- Schlieventil ein
  WaitForInput(pFishFace, ctTuerZu);            // --- Warten auf Schlieen
  SetMotor(pFishFace, cvTuerZu, ftiAus);        // --- Schlieventil aus
end;

end.
